package org.xtext.example.mydsl7.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.mydsl7.services.MyDsl7GrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMyDsl7Parser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'Hello'", "'!'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_STRING=6;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

    // delegates
    // delegators


        public InternalMyDsl7Parser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMyDsl7Parser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMyDsl7Parser.tokenNames; }
    public String getGrammarFileName() { return "../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g"; }



     	private MyDsl7GrammarAccess grammarAccess;
     	
        public InternalMyDsl7Parser(TokenStream input, MyDsl7GrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "Model7";	
       	}
       	
       	@Override
       	protected MyDsl7GrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleModel7"
    // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:67:1: entryRuleModel7 returns [EObject current=null] : iv_ruleModel7= ruleModel7 EOF ;
    public final EObject entryRuleModel7() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModel7 = null;


        try {
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:68:2: (iv_ruleModel7= ruleModel7 EOF )
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:69:2: iv_ruleModel7= ruleModel7 EOF
            {
             newCompositeNode(grammarAccess.getModel7Rule()); 
            pushFollow(FOLLOW_ruleModel7_in_entryRuleModel775);
            iv_ruleModel7=ruleModel7();

            state._fsp--;

             current =iv_ruleModel7; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleModel785); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModel7"


    // $ANTLR start "ruleModel7"
    // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:76:1: ruleModel7 returns [EObject current=null] : ( (lv_greetings_0_0= ruleGreeting7 ) )* ;
    public final EObject ruleModel7() throws RecognitionException {
        EObject current = null;

        EObject lv_greetings_0_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:79:28: ( ( (lv_greetings_0_0= ruleGreeting7 ) )* )
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:80:1: ( (lv_greetings_0_0= ruleGreeting7 ) )*
            {
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:80:1: ( (lv_greetings_0_0= ruleGreeting7 ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:81:1: (lv_greetings_0_0= ruleGreeting7 )
            	    {
            	    // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:81:1: (lv_greetings_0_0= ruleGreeting7 )
            	    // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:82:3: lv_greetings_0_0= ruleGreeting7
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getModel7Access().getGreetingsGreeting7ParserRuleCall_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleGreeting7_in_ruleModel7130);
            	    lv_greetings_0_0=ruleGreeting7();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getModel7Rule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"greetings",
            	            		lv_greetings_0_0, 
            	            		"Greeting7");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModel7"


    // $ANTLR start "entryRuleGreeting7"
    // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:106:1: entryRuleGreeting7 returns [EObject current=null] : iv_ruleGreeting7= ruleGreeting7 EOF ;
    public final EObject entryRuleGreeting7() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGreeting7 = null;


        try {
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:107:2: (iv_ruleGreeting7= ruleGreeting7 EOF )
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:108:2: iv_ruleGreeting7= ruleGreeting7 EOF
            {
             newCompositeNode(grammarAccess.getGreeting7Rule()); 
            pushFollow(FOLLOW_ruleGreeting7_in_entryRuleGreeting7166);
            iv_ruleGreeting7=ruleGreeting7();

            state._fsp--;

             current =iv_ruleGreeting7; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleGreeting7176); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGreeting7"


    // $ANTLR start "ruleGreeting7"
    // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:115:1: ruleGreeting7 returns [EObject current=null] : (otherlv_0= 'Hello' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '!' ) ;
    public final EObject ruleGreeting7() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;

         enterRule(); 
            
        try {
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:118:28: ( (otherlv_0= 'Hello' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '!' ) )
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:119:1: (otherlv_0= 'Hello' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '!' )
            {
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:119:1: (otherlv_0= 'Hello' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '!' )
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:119:3: otherlv_0= 'Hello' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '!'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_11_in_ruleGreeting7213); 

                	newLeafNode(otherlv_0, grammarAccess.getGreeting7Access().getHelloKeyword_0());
                
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:123:1: ( (lv_name_1_0= RULE_ID ) )
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:124:1: (lv_name_1_0= RULE_ID )
            {
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:124:1: (lv_name_1_0= RULE_ID )
            // ../org.xtext.example.mydsl7/src-gen/org/xtext/example/mydsl7/parser/antlr/internal/InternalMyDsl7.g:125:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleGreeting7230); 

            			newLeafNode(lv_name_1_0, grammarAccess.getGreeting7Access().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getGreeting7Rule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_ruleGreeting7247); 

                	newLeafNode(otherlv_2, grammarAccess.getGreeting7Access().getExclamationMarkKeyword_2());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGreeting7"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleModel7_in_entryRuleModel775 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleModel785 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleGreeting7_in_ruleModel7130 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_ruleGreeting7_in_entryRuleGreeting7166 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleGreeting7176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleGreeting7213 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleGreeting7230 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleGreeting7247 = new BitSet(new long[]{0x0000000000000002L});

}